Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 74430)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -1147,51 +781,26 @@
             me->dummyfileref->fcb = me->dummyfcb;
         
         InterlockedIncrement(&me->dummyfileref->fcb->refcount);
-
-        me->dummyfileref->filepart = me->fileref->filepart;
         
-        if (le == move_list.Flink) // first item
-            me->fileref->filepart.Length = me->fileref->filepart.MaximumLength = fnus->Length;
-        else
-            me->fileref->filepart.MaximumLength = me->fileref->filepart.Length;
-        
-        me->fileref->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->filepart.MaximumLength, ALLOC_TAG);
-        
-        if (!me->fileref->filepart.Buffer) {
-            ERR("out of memory\n");
-            Status = STATUS_INSUFFICIENT_RESOURCES;
-            goto end;
-        }
-        
-        RtlCopyMemory(me->fileref->filepart.Buffer, le == move_list.Flink ? fnus->Buffer : me->dummyfileref->filepart.Buffer, me->fileref->filepart.Length);
-        
-        Status = RtlUpcaseUnicodeString(&me->fileref->filepart_uc, &me->fileref->filepart, TRUE);
-        if (!NT_SUCCESS(Status)) {
-            ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-            goto end;
-        }
-        
-        me->dummyfileref->utf8 = me->fileref->utf8;
         me->dummyfileref->oldutf8 = me->fileref->oldutf8;
+        me->dummyfileref->oldindex = me->fileref->dc->index;
         
         if (le == move_list.Flink) {
-            if (me->fileref->utf8.Length != utf8->Length || RtlCompareMemory(me->fileref->utf8.Buffer, utf8->Buffer, utf8->Length) != utf8->Length)
+            if (me->fileref->dc->utf8.Length != utf8->Length || RtlCompareMemory(me->fileref->dc->utf8.Buffer, utf8->Buffer, utf8->Length) != utf8->Length)
                 name_changed = TRUE;
             
-            me->fileref->utf8.Length = me->fileref->utf8.MaximumLength = utf8->Length;
-        } else
-            me->fileref->utf8.MaximumLength = me->fileref->utf8.Length;
-        
-        if (me->fileref->utf8.MaximumLength > 0) {
-            me->fileref->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->utf8.MaximumLength, ALLOC_TAG);
-            
-            if (!me->fileref->utf8.Buffer) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
-                goto end;
+            if (!me->dummyfileref->oldutf8.Buffer) {
+                me->dummyfileref->oldutf8.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->dc->utf8.Length, ALLOC_TAG);
+                if (!me->dummyfileref->oldutf8.Buffer) {
+                    ERR("out of memory\n");
+                    Status = STATUS_INSUFFICIENT_RESOURCES;
+                    goto end;
+                }
+                
+                RtlCopyMemory(me->dummyfileref->oldutf8.Buffer, me->fileref->dc->utf8.Buffer, me->fileref->dc->utf8.Length);
+                
+                me->dummyfileref->oldutf8.Length = me->dummyfileref->oldutf8.MaximumLength = me->fileref->dc->utf8.Length;
             }
-            
-            RtlCopyMemory(me->fileref->utf8.Buffer, le == move_list.Flink ? utf8->Buffer : me->dummyfileref->utf8.Buffer, me->fileref->utf8.Length);
         }
         
         me->dummyfileref->delete_on_close = me->fileref->delete_on_close;
@@ -1202,10 +811,10 @@
         
         me->dummyfileref->parent = me->parent ? me->parent->dummyfileref : origparent;
         increase_fileref_refcount(me->dummyfileref->parent);
-        
-        me->dummyfileref->index = me->fileref->index;
 
-        insert_fileref_child(me->dummyfileref->parent, me->dummyfileref, TRUE);
+        ExAcquireResourceExclusiveLite(&me->dummyfileref->parent->nonpaged->children_lock, TRUE);
+        InsertTailList(&me->dummyfileref->parent->children, &me->dummyfileref->list_entry);
+        ExReleaseResourceLite(&me->dummyfileref->parent->nonpaged->children_lock);
        
         me->dummyfileref->debug_desc = me->fileref->debug_desc;
         
@@ -1215,16 +824,8 @@
         if (!me->parent) {
             RemoveEntryList(&me->fileref->list_entry);
             
-            free_fileref(me->fileref->parent);
-            
             increase_fileref_refcount(destdir);
             
-            Status = fcb_get_last_dir_index(destdir->fcb, &me->fileref->index, Irp);
-            if (!NT_SUCCESS(Status)) {
-                ERR("fcb_get_last_dir_index returned %08x\n", Status);
-                goto end;
-            }
-            
             if (me->fileref->dc) {
                 // remove from old parent
                 ExAcquireResourceExclusiveLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock, TRUE);
@@ -1232,6 +833,14 @@
                 remove_dir_child_from_hash_lists(me->fileref->parent->fcb, me->fileref->dc);
                 ExReleaseResourceLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock);
                 
+                me->fileref->parent->fcb->inode_item.st_size -= me->fileref->dc->utf8.Length * 2;
+                me->fileref->parent->fcb->inode_item.transid = me->fileref->fcb->Vcb->superblock.generation;
+                me->fileref->parent->fcb->inode_item.sequence++;
+                me->fileref->parent->fcb->inode_item.st_ctime = now;
+                me->fileref->parent->fcb->inode_item.st_mtime = now;
+                me->fileref->parent->fcb->inode_item_changed = TRUE;
+                mark_fcb_dirty(me->fileref->parent->fcb);
+                
                 if (name_changed) {
                     ExFreePool(me->fileref->dc->utf8.Buffer);
                     ExFreePool(me->fileref->dc->name.Buffer);
@@ -1244,7 +853,10 @@
                         goto end;
                     }
                     
-                    me->fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->filepart.Length, ALLOC_TAG);
+                    me->fileref->dc->utf8.Length = me->fileref->dc->utf8.MaximumLength = utf8->Length;
+                    RtlCopyMemory(me->fileref->dc->utf8.Buffer, utf8->Buffer, utf8->Length);
+                    
+                    me->fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus->Length, ALLOC_TAG);
                     if (!me->fileref->dc->name.Buffer) {
                         ERR("out of memory\n");
                         Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -1251,39 +863,48 @@
                         goto end;
                     }
                     
-                    me->fileref->dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, me->fileref->filepart_uc.Length, ALLOC_TAG);
-                    if (!me->fileref->dc->name_uc.Buffer) {
-                        ERR("out of memory\n");
-                        Status = STATUS_INSUFFICIENT_RESOURCES;
+                    me->fileref->dc->name.Length = me->fileref->dc->name.MaximumLength = fnus->Length;
+                    RtlCopyMemory(me->fileref->dc->name.Buffer, fnus->Buffer, fnus->Length);
+                    
+                    Status = RtlUpcaseUnicodeString(&fileref->dc->name_uc, &fileref->dc->name, TRUE);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                         goto end;
                     }
                     
-                    me->fileref->dc->utf8.Length = me->fileref->dc->utf8.MaximumLength = utf8->Length;
-                    RtlCopyMemory(me->fileref->dc->utf8.Buffer, utf8->Buffer, utf8->Length);
-                    
-                    me->fileref->dc->name.Length = me->fileref->dc->name.MaximumLength = me->fileref->filepart.Length;
-                    RtlCopyMemory(me->fileref->dc->name.Buffer, me->fileref->filepart.Buffer, me->fileref->filepart.Length);
-                    
-                    me->fileref->dc->name_uc.Length = me->fileref->dc->name_uc.MaximumLength = me->fileref->filepart_uc.Length;
-                    RtlCopyMemory(me->fileref->dc->name_uc.Buffer, me->fileref->filepart_uc.Buffer, me->fileref->filepart_uc.Length);
-                    
                     me->fileref->dc->hash = calc_crc32c(0xffffffff, (UINT8*)me->fileref->dc->name.Buffer, me->fileref->dc->name.Length);
                     me->fileref->dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)me->fileref->dc->name_uc.Buffer, me->fileref->dc->name_uc.Length);
                 }
                 
+                if (me->fileref->dc->key.obj_type == TYPE_INODE_ITEM)
+                    me->fileref->dc->key.obj_id = me->fileref->fcb->inode;
+                
                 // add to new parent
+                
                 ExAcquireResourceExclusiveLite(&destdir->fcb->nonpaged->dir_children_lock, TRUE);
+                
+                if (IsListEmpty(&destdir->fcb->dir_children_index))
+                    me->fileref->dc->index = 2;
+                else {
+                    dir_child* dc2 = CONTAINING_RECORD(destdir->fcb->dir_children_index.Blink, dir_child, list_entry_index);
+                    
+                    me->fileref->dc->index = max(2, dc2->index + 1);
+                }
+                
                 InsertTailList(&destdir->fcb->dir_children_index, &me->fileref->dc->list_entry_index);
                 insert_dir_child_into_hash_lists(destdir->fcb, me->fileref->dc);
                 ExReleaseResourceLite(&destdir->fcb->nonpaged->dir_children_lock);
             }
             
+            free_fileref(fileref->fcb->Vcb, me->fileref->parent);
             me->fileref->parent = destdir;
             
-            insert_fileref_child(me->fileref->parent, me->fileref, TRUE);
+            ExAcquireResourceExclusiveLite(&me->fileref->parent->nonpaged->children_lock, TRUE);
+            InsertTailList(&me->fileref->parent->children, &me->fileref->list_entry);
+            ExReleaseResourceLite(&me->fileref->parent->nonpaged->children_lock);
             
             TRACE("me->fileref->parent->fcb->inode_item.st_size (inode %llx) was %llx\n", me->fileref->parent->fcb->inode, me->fileref->parent->fcb->inode_item.st_size);
-            me->fileref->parent->fcb->inode_item.st_size += me->fileref->utf8.Length * 2;
+            me->fileref->parent->fcb->inode_item.st_size += me->fileref->dc->utf8.Length * 2;
             TRACE("me->fileref->parent->fcb->inode_item.st_size (inode %llx) now %llx\n", me->fileref->parent->fcb->inode, me->fileref->parent->fcb->inode_item.st_size);
             me->fileref->parent->fcb->inode_item.transid = me->fileref->fcb->Vcb->superblock.generation;
             me->fileref->parent->fcb->inode_item.sequence++;
@@ -1291,6 +912,31 @@
             me->fileref->parent->fcb->inode_item.st_mtime = now;
             me->fileref->parent->fcb->inode_item_changed = TRUE;
             mark_fcb_dirty(me->fileref->parent->fcb);
+        } else {
+            if (me->fileref->dc) {
+                ExAcquireResourceExclusiveLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock, TRUE);
+                RemoveEntryList(&me->fileref->dc->list_entry_index);
+                
+                if (!me->fileref->fcb->ads)
+                    remove_dir_child_from_hash_lists(me->fileref->parent->fcb, me->fileref->dc);
+                
+                ExReleaseResourceLite(&me->fileref->parent->fcb->nonpaged->dir_children_lock);
+                
+                if (me->fileref->fcb->inode != SUBVOL_ROOT_INODE) {
+                    ExAcquireResourceExclusiveLite(&me->parent->fileref->fcb->nonpaged->dir_children_lock, TRUE);
+                    
+                    if (me->fileref->fcb->ads)
+                        InsertHeadList(&me->parent->fileref->fcb->dir_children_index, &me->fileref->dc->list_entry_index);
+                    else {
+                        me->fileref->dc->key.obj_id = me->fileref->fcb->inode;
+                        
+                        InsertTailList(&me->parent->fileref->fcb->dir_children_index, &me->fileref->dc->list_entry_index);
+                        insert_dir_child_into_hash_lists(me->parent->fileref->fcb, me->fileref->dc);
+                    }
+                    
+                    ExReleaseResourceLite(&me->parent->fileref->fcb->nonpaged->dir_children_lock);
+                }
+            }
         }
 
         if (me->fileref->fcb->inode == SUBVOL_ROOT_INODE)
@@ -1313,9 +959,9 @@
             }
             
             hl->parent = me->fileref->parent->fcb->inode;
-            hl->index = me->fileref->index;
+            hl->index = me->fileref->dc->index;
             
-            hl->utf8.Length = hl->utf8.MaximumLength = me->fileref->utf8.Length;
+            hl->utf8.Length = hl->utf8.MaximumLength = me->fileref->dc->utf8.Length;
             hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
             if (!hl->utf8.Buffer) {
                 ERR("out of memory\n");
@@ -1324,9 +970,9 @@
                 goto end;
             }
             
-            RtlCopyMemory(hl->utf8.Buffer, me->fileref->utf8.Buffer, me->fileref->utf8.Length);
+            RtlCopyMemory(hl->utf8.Buffer, me->fileref->dc->utf8.Buffer, me->fileref->dc->utf8.Length);
             
-            hl->name.Length = hl->name.MaximumLength = me->fileref->filepart.Length;
+            hl->name.Length = hl->name.MaximumLength = me->fileref->dc->name.Length;
             hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
             if (!hl->name.Buffer) {
                 ERR("out of memory\n");
@@ -1336,7 +982,7 @@
                 goto end;
             }
             
-            RtlCopyMemory(hl->name.Buffer, me->fileref->filepart.Buffer, me->fileref->filepart.Length);
+            RtlCopyMemory(hl->name.Buffer, me->fileref->dc->name.Buffer, me->fileref->dc->name.Length);
             
             InsertTailList(&me->fileref->fcb->hardlinks, &hl->list_entry);
         }
@@ -1367,7 +1013,6 @@
     destdir->fcb->subvol->root_item.ctime = now;
     
     me = CONTAINING_RECORD(move_list.Flink, move_entry, list_entry);
-    send_notification_fileref(me->dummyfileref, fileref->fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
     send_notification_fileref(fileref, fileref->fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED);
     send_notification_fileref(me->dummyfileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
     send_notification_fileref(fileref->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
@@ -1383,9 +1028,9 @@
             free_fcb(me->dummyfcb);
         
         if (me->dummyfileref)
-            free_fileref(me->dummyfileref);
+            free_fileref(fileref->fcb->Vcb, me->dummyfileref);
         
-        free_fileref(me->fileref);
+        free_fileref(fileref->fcb->Vcb, me->fileref);
         
         ExFreePool(me);
     }
@@ -1487,9 +1132,8 @@
     fcb *fcb = FileObject->FsContext;
     ccb* ccb = FileObject->FsContext2;
     file_ref *fileref = ccb ? ccb->fileref : NULL, *oldfileref = NULL, *related = NULL, *fr2 = NULL;
-    UINT64 index;
     WCHAR* fn;
-    ULONG fnlen, utf8len;
+    ULONG fnlen, utf8len, origutf8len;
     UNICODE_STRING fnus;
     ANSI_STRING utf8;
     NTSTATUS Status;
@@ -1536,8 +1180,10 @@
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
     
     if (fcb->ads) {
-        FIXME("FIXME - renaming streams\n"); // FIXME
-        Status = STATUS_NOT_IMPLEMENTED;
+        // MSDN says that NTFS data streams can be renamed (https://msdn.microsoft.com/en-us/library/windows/hardware/ff540344.aspx),
+        // but if you try it always seems to return STATUS_INVALID_PARAMETER. There is a function in ntfs.sys called NtfsStreamRename,
+        // but it never seems to get invoked... If you know what's going on here, I'd appreciate it if you let me know.
+        Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
     
@@ -1546,6 +1192,8 @@
     
     TRACE("fnus = %.*S\n", fnus.Length / sizeof(WCHAR), fnus.Buffer);
     
+    origutf8len = fileref->dc->utf8.Length;
+    
     Status = RtlUnicodeToUTF8N(NULL, 0, &utf8len, fn, (ULONG)fnlen * sizeof(WCHAR));
     if (!NT_SUCCESS(Status))
         goto end;
@@ -1595,7 +1243,7 @@
         }
         
         if (fileref == oldfileref || oldfileref->deleted) {
-            free_fileref(oldfileref);
+            free_fileref(Vcb, oldfileref);
             oldfileref = NULL;
         }
     }
@@ -1624,7 +1272,7 @@
         if (!SeAccessCheck(oldfileref->fcb->sd, &subjcont, FALSE, DELETE, 0, NULL,
                            IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
             SeReleaseSubjectContext(&subjcont);
-            WARN("SeAccessCheck failed, returning %08x\n", Status);
+            TRACE("SeAccessCheck failed, returning %08x\n", Status);
             goto end;
         }
 
@@ -1638,7 +1286,7 @@
     }
     
     if (fileref->parent->fcb->subvol != related->fcb->subvol && fileref->fcb->subvol == fileref->parent->fcb->subvol) {
-        Status = move_across_subvols(fileref, related, &utf8, &fnus, Irp, &rollback);
+        Status = move_across_subvols(fileref, ccb, related, &utf8, &fnus, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("move_across_subvols returned %08x\n", Status);
         }
@@ -1646,51 +1294,72 @@
     }
     
     if (related == fileref->parent) { // keeping file in same directory
-        UNICODE_STRING fnus2, oldfn, newfn;
+        UNICODE_STRING oldfn, newfn;
         USHORT name_offset;
-        ULONG oldutf8len;
+        ULONG reqlen, oldutf8len;
         
-        fnus2.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
-        if (!fnus2.Buffer) {
+        oldfn.Length = oldfn.MaximumLength = 0;
+        
+        Status = fileref_get_filename(fileref, &oldfn, &name_offset, &reqlen);
+        if (Status != STATUS_BUFFER_OVERFLOW) {
+            ERR("fileref_get_filename returned %08x\n", Status);
+            goto end;
+        }
+        
+        oldfn.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+        if (!oldfn.Buffer) {
             ERR("out of memory\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
         
-        Status = fileref_get_filename(fileref, &oldfn, &name_offset);
+        oldfn.MaximumLength = reqlen;
+        
+        Status = fileref_get_filename(fileref, &oldfn, &name_offset, &reqlen);
         if (!NT_SUCCESS(Status)) {
             ERR("fileref_get_filename returned %08x\n", Status);
+            ExFreePool(oldfn.Buffer);
             goto end;
         }
         
-        fnus2.Length = fnus2.MaximumLength = fnus.Length;
-        RtlCopyMemory(fnus2.Buffer, fnus.Buffer, fnus.Length);
+        oldutf8len = fileref->dc->utf8.Length;
         
-        oldutf8len = fileref->utf8.Length;
+        if (!fileref->created && !fileref->oldutf8.Buffer) {
+            fileref->oldutf8.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->dc->utf8.Length, ALLOC_TAG);
+            if (!fileref->oldutf8.Buffer) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
+            }
+            
+            fileref->oldutf8.Length = fileref->oldutf8.MaximumLength = fileref->dc->utf8.Length;
+            RtlCopyMemory(fileref->oldutf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+        }
         
-        if (!fileref->created && !fileref->oldutf8.Buffer)
-            fileref->oldutf8 = fileref->utf8;
-        else
-            ExFreePool(fileref->utf8.Buffer);
+        TRACE("renaming %.*S to %.*S\n", fileref->dc->name.Length / sizeof(WCHAR), fileref->dc->name.Buffer, fnus.Length / sizeof(WCHAR), fnus.Buffer);
         
-        TRACE("renaming %.*S to %.*S\n", fileref->filepart.Length / sizeof(WCHAR), fileref->filepart.Buffer, fnus2.Length / sizeof(WCHAR), fnus.Buffer);
+        newfn.Length = newfn.MaximumLength = 0;
         
-        fileref->utf8 = utf8;
-        fileref->filepart = fnus2;
-        
-        Status = fileref_get_filename(fileref, &newfn, &name_offset);
-        if (!NT_SUCCESS(Status)) {
+        Status = fileref_get_filename(fileref, &newfn, &name_offset, &reqlen);
+        if (Status != STATUS_BUFFER_OVERFLOW) {
             ERR("fileref_get_filename returned %08x\n", Status);
             ExFreePool(oldfn.Buffer);
             goto end;
         }
         
-        if (fileref->filepart_uc.Buffer)
-            ExFreePool(fileref->filepart_uc.Buffer);
+        newfn.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+        if (!newfn.Buffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            ExFreePool(oldfn.Buffer);
+            goto end;
+        }
         
-        Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
+        newfn.MaximumLength = reqlen;
+        
+        Status = fileref_get_filename(fileref, &newfn, &name_offset, &reqlen);
         if (!NT_SUCCESS(Status)) {
-            ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
+            ERR("fileref_get_filename returned %08x\n", Status);
             ExFreePool(oldfn.Buffer);
             ExFreePool(newfn.Buffer);
             goto end;
@@ -1710,34 +1379,36 @@
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
+                ExFreePool(oldfn.Buffer);
+                ExFreePool(newfn.Buffer);
                 goto end;
             }
             
-            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart.Length, ALLOC_TAG);
+            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
+            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
+            
+            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
             if (!fileref->dc->name.Buffer) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
+                ExFreePool(oldfn.Buffer);
+                ExFreePool(newfn.Buffer);
                 goto end;
             }
             
-            fileref->dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart_uc.Length, ALLOC_TAG);
-            if (!fileref->dc->name_uc.Buffer) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
+            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fnus.Length;
+            RtlCopyMemory(fileref->dc->name.Buffer, fnus.Buffer, fnus.Length);
+
+            Status = RtlUpcaseUnicodeString(&fileref->dc->name_uc, &fileref->dc->name, TRUE);
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                 ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
+                ExFreePool(oldfn.Buffer);
+                ExFreePool(newfn.Buffer);
                 goto end;
             }
             
-            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
-            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
-            
-            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fileref->filepart.Length;
-            RtlCopyMemory(fileref->dc->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
-            
-            fileref->dc->name_uc.Length = fileref->dc->name_uc.MaximumLength = fileref->filepart_uc.Length;
-            RtlCopyMemory(fileref->dc->name_uc.Buffer, fileref->filepart_uc.Buffer, fileref->filepart_uc.Length);
-            
             remove_dir_child_from_hash_lists(fileref->parent->fcb, fileref->dc);
             
             fileref->dc->hash = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name.Buffer, fileref->dc->name.Length);
@@ -1751,15 +1422,17 @@
         KeQuerySystemTime(&time);
         win_time_to_unix(time, &now);
         
-        fcb->inode_item.transid = Vcb->superblock.generation;
-        fcb->inode_item.sequence++;
+        if (fileref->parent->fcb->subvol == fcb->subvol || !(fcb->subvol->root_item.flags & BTRFS_SUBVOL_READONLY)) {
+            fcb->inode_item.transid = Vcb->superblock.generation;
+            fcb->inode_item.sequence++;
+            
+            if (!ccb->user_set_change_time)
+                fcb->inode_item.st_ctime = now;
+            
+            fcb->inode_item_changed = TRUE;
+            mark_fcb_dirty(fcb);
+        }
         
-        if (!ccb->user_set_change_time)
-            fcb->inode_item.st_ctime = now;
-        
-        fcb->inode_item_changed = TRUE;
-        mark_fcb_dirty(fcb);
-        
         // update parent's INODE_ITEM
         
         related->fcb->inode_item.transid = Vcb->superblock.generation;
@@ -1789,16 +1462,15 @@
     // We move files by moving the existing fileref to the new directory, and
     // replacing it with a dummy fileref with the same original values, but marked as deleted.
     
-    fr2 = create_fileref();
+    send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
     
+    fr2 = create_fileref(Vcb);
+    
     fr2->fcb = fileref->fcb;
     fr2->fcb->refcount++;
     
-    fr2->filepart = fileref->filepart;
-    fr2->filepart_uc = fileref->filepart_uc;
-    fr2->utf8 = fileref->utf8;
     fr2->oldutf8 = fileref->oldutf8;
-    fr2->index = fileref->index;
+    fr2->oldindex = fileref->dc->index;
     fr2->delete_on_close = fileref->delete_on_close;
     fr2->deleted = TRUE;
     fr2->created = fileref->created;
@@ -1805,34 +1477,24 @@
     fr2->parent = fileref->parent;
     fr2->dc = NULL;
     
+    if (!fr2->oldutf8.Buffer) {
+        fr2->oldutf8.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->dc->utf8.Length, ALLOC_TAG);
+        if (!fr2->oldutf8.Buffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+        
+        RtlCopyMemory(fr2->oldutf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+        
+        fr2->oldutf8.Length = fr2->oldutf8.MaximumLength = fileref->dc->utf8.Length;
+    }
+    
     if (fr2->fcb->type == BTRFS_TYPE_DIRECTORY)
         fr2->fcb->fileref = fr2;
-
-    Status = fcb_get_last_dir_index(related->fcb, &index, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        goto end;
-    }
     
-    fileref->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
-    if (!fileref->filepart.Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    fileref->filepart.Length = fileref->filepart.MaximumLength = fnus.Length;
-    RtlCopyMemory(fileref->filepart.Buffer, fnus.Buffer, fnus.Length);
-    
-    Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        goto end;
-    }
-    
-    fileref->utf8 = utf8;
+    fileref->oldutf8.Length = fileref->oldutf8.MaximumLength = 0;
     fileref->oldutf8.Buffer = NULL;
-    fileref->index = index;
     fileref->deleted = FALSE;
     fileref->created = TRUE;
     fileref->parent = related;
@@ -1842,8 +1504,6 @@
     RemoveEntryList(&fileref->list_entry);
     ExReleaseResourceLite(&fileref->parent->nonpaged->children_lock);
     
-    insert_fileref_child(related, fileref, TRUE);
-    
     mark_fileref_dirty(fr2);
     mark_fileref_dirty(fileref);
     
@@ -1854,7 +1514,7 @@
         remove_dir_child_from_hash_lists(fr2->parent->fcb, fileref->dc);
         ExReleaseResourceLite(&fr2->parent->fcb->nonpaged->dir_children_lock);
         
-        if (fileref->utf8.Length != fr2->utf8.Length || RtlCompareMemory(fileref->utf8.Buffer, fr2->utf8.Buffer, fr2->utf8.Length) != fr2->utf8.Length) {
+        if (fileref->dc->utf8.Length != utf8.Length || RtlCompareMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length) != utf8.Length) {
             // handle changed name
             
             ExFreePool(fileref->dc->utf8.Buffer);
@@ -1868,7 +1528,10 @@
                 goto end;
             }
             
-            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart.Length, ALLOC_TAG);
+            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
+            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
+            
+            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
             if (!fileref->dc->name.Buffer) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
@@ -1875,22 +1538,15 @@
                 goto end;
             }
             
-            fileref->dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart_uc.Length, ALLOC_TAG);
-            if (!fileref->dc->name_uc.Buffer) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
+            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fnus.Length;
+            RtlCopyMemory(fileref->dc->name.Buffer, fnus.Buffer, fnus.Length);
+            
+            Status = RtlUpcaseUnicodeString(&fileref->dc->name_uc, &fileref->dc->name, TRUE);
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                 goto end;
             }
             
-            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
-            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
-            
-            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fileref->filepart.Length;
-            RtlCopyMemory(fileref->dc->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
-            
-            fileref->dc->name_uc.Length = fileref->dc->name_uc.MaximumLength = fileref->filepart_uc.Length;
-            RtlCopyMemory(fileref->dc->name_uc.Buffer, fileref->filepart_uc.Buffer, fileref->filepart_uc.Length);
-            
             fileref->dc->hash = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name.Buffer, fileref->dc->name.Length);
             fileref->dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name_uc.Buffer, fileref->dc->name_uc.Length);
         }
